Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
radm::KvmManager Interface Reference

## Classes
struct | CimFirmwareInfo
struct | CimFirmwareUpdateCompletedEvent
| Event: CIM firmware updated successfully. More...
struct | CimFirmwareUpdateEvent
| Event: Firmware update base event. More...
struct | CimFirmwareUpdateStartedEvent
| Event: CIM firmware update started. More...
struct | CimUpdateHistoryEntry
struct | KvmAccessFlags
struct | KvmAccessModeChangedEvent
| Event: Access mode flags have changed. More...
struct | KvmSecuritySettingsChangedEvent
| Event: The KVM security settings have changed. More...
struct | SecuritySettings
struct | VirtualMediaShare
| Data structure for a preconfigured virtual media ISO file on an SMB share. More...
struct | VirtualMediaSharesChangedEvent
| Event: The list of configured virtual media shares has changed. More...

## Public Types
enum | ResetPinMode { FACTORY_RESET , ADMIN_PASSWORD_RESET , DISABLE_ALL_RESET }
enum | ControlPriority { PRIORITY_NONE , PRIORITY_LOCAL , PRIORITY_REMOTE }
enum | KvmAccessMode { FULL_ACCESS , VIEW_ONLY , DENY }

## Public Member Functions
KvmDevice | getKvmDevice ()
| Get KVM device.
vector< KvmChannel > | getKvmChannels ()
| Get KVM channels.
vector< PowerSupply > | getPowerSupplies ()
| Get power supplies.
PowerDeviceManager | getPowerDeviceManager ()
| Get power device (PDU) manager.
DsamDeviceManager | getDsamDeviceManager ()
| Get serial device (DSAM) manager.
PortGroupManager | getPortGroupManager ()
| Get port group manager.
KeySetManager | getKeySetManager ()
| Get key set manager.
AutoScan | getAutoScan ()
| Get auto scan instance.
SecuritySettings | getSecuritySettings ()
| Get device security settings.
int | setSecuritySettings (in SecuritySettings settings)
| Set device security settings.
vector< VirtualMediaShare > | getVirtualMediaShares ()
| Get configured virtual media shares.
int | setVirtualMediaShares (in vector< VirtualMediaShare > shares)
| Configure virtual media shares.
int | testVirtualMediaShare (in VirtualMediaShare share, in string username, in string password, out string errorDetails)
| Test a virtual media share.
KvmAccessFlags | getKvmAccessMode ()
| Get current KVM access modes.
vector< CimFirmwareInfo > | getAvailableCimFirmwareVersions ()
| Get information about available CIM firmwares.
vector< CimUpdateHistoryEntry > | getCimUpdateHistory ()
| Fetch the CIM firmware update history.
void | startCimUpdate (in vector< KvmPort > ports)
| Start CIM firmware update for selected CIMs.

## Public Attributes
constant int | ERR_INVALID_ARGUMENT = 1
constant int | ERR_VM_SHARE_INACCESSIBLE = 2
constant int | ERR_IMAGE_NOT_USABLE = 3

## Detailed Description

Definition at line 18 of file KvmManager.idl.

## Member Enumeration Documentation

## ◆ ControlPriority

enum radm::KvmManager::ControlPriority

Enumerator
PRIORITY_NONE | No prioritization, first operator gets control.
PRIORITY_LOCAL | Prioritize operation via locally attached input device.
PRIORITY_REMOTE | Prioritize operation via remote KVM client.

Definition at line 29 of file KvmManager.idl.

## ◆ KvmAccessMode

enum radm::KvmManager::KvmAccessMode

Enumerator
FULL_ACCESS | Both viewing and control are possible.
VIEW_ONLY | Only viewing is possible.
DENY | Neither viewing nor control are possible.

Definition at line 56 of file KvmManager.idl.

## ◆ ResetPinMode

enum radm::KvmManager::ResetPinMode

Enumerator
FACTORY_RESET | Trigger a factory reset.
ADMIN_PASSWORD_RESET | Trigger a reset of the admin password.
DISABLE_ALL_RESET | Disable local reset.

Definition at line 23 of file KvmManager.idl.

## Member Function Documentation

## ◆ getAutoScan()

AutoScan radm::KvmManager::getAutoScan | ( |  | ) |

Get auto scan instance.

Returns
  Auto scan instance (if supported by device)

## ◆ getAvailableCimFirmwareVersions()

vector< CimFirmwareInfo > radm::KvmManager::getAvailableCimFirmwareVersions | ( |  | ) |

Get information about available CIM firmwares.

Returns
  CIM firmware information

## ◆ getCimUpdateHistory()

vector< CimUpdateHistoryEntry > radm::KvmManager::getCimUpdateHistory | ( |  | ) |

Fetch the CIM firmware update history.

Returns
  List of CIM firmware update history entries

## ◆ getDsamDeviceManager()

DsamDeviceManager radm::KvmManager::getDsamDeviceManager | ( |  | ) |

Get serial device (DSAM) manager.

Returns
  DSAM manager (if supported by device)

## ◆ getKeySetManager()

KeySetManager radm::KvmManager::getKeySetManager | ( |  | ) |

Get key set manager.

Returns
  Key set manager

## ◆ getKvmAccessMode()

KvmAccessFlags radm::KvmManager::getKvmAccessMode | ( |  | ) |

Get current KVM access modes.

Returns
  Access modes for local and remote operation

## ◆ getKvmChannels()

vector< KvmChannel > radm::KvmManager::getKvmChannels | ( |  | ) |

Get KVM channels.

Returns
  List of available KVM channels

## ◆ getKvmDevice()

KvmDevice radm::KvmManager::getKvmDevice | ( |  | ) |

Get KVM device.

Returns
  KVM device

## ◆ getPortGroupManager()

PortGroupManager radm::KvmManager::getPortGroupManager | ( |  | ) |

Get port group manager.

Returns
  Port group manager (if supported by device)

## ◆ getPowerDeviceManager()

PowerDeviceManager radm::KvmManager::getPowerDeviceManager | ( |  | ) |

Get power device (PDU) manager.

Returns
  PDU manager (if supported by device)

## ◆ getPowerSupplies()

vector< PowerSupply > radm::KvmManager::getPowerSupplies | ( |  | ) |

Get power supplies.

Returns
  List of power supplies, or empty list in case power supply monitoring is not supported

## ◆ getSecuritySettings()

SecuritySettings radm::KvmManager::getSecuritySettings | ( |  | ) |

Get device security settings.

Returns
  Security settings

## ◆ getVirtualMediaShares()

vector< VirtualMediaShare > radm::KvmManager::getVirtualMediaShares | ( |  | ) |

Get configured virtual media shares.

Returns
  list of configured virtual media shares

## ◆ setSecuritySettings()

int radm::KvmManager::setSecuritySettings | ( | in SecuritySettings | settings | ) |

Set device security settings.

Parameters

  settings | New security settings

Returns
  0 on success
  1 if any setting was invalid

## ◆ setVirtualMediaShares()

int radm::KvmManager::setVirtualMediaShares | ( | in vector< VirtualMediaShare > | shares | ) |

Configure virtual media shares.

Note: At most 10 shares can be configured

Parameters

  shares | New list of shares to be sent to KVM clients

Returns
  0 on success
  1 in case either the list was too long, or any value was invalid

## ◆ startCimUpdate()

void radm::KvmManager::startCimUpdate | ( | in vector< KvmPort > | ports | ) |

Start CIM firmware update for selected CIMs.

Parameters

  ports | List of ports to which the CIMs to be updated are connected

## ◆ testVirtualMediaShare()

int radm::KvmManager::testVirtualMediaShare | ( | in VirtualMediaShare | share,
|  | in string | username,
|  | in string | password,
|  | out string | errorDetails )

Test a virtual media share.

Parameters

  share | Configuration of the share
  username | User name for accessing the share
  password | Password for accessing the share
  errorDetails | Additional error details in case of inaccessible VM share

Returns
  0 on success
  2 if SMB share can not be accessed
  3 if image path does not exist on the share or is not a valid image

## Member Data Documentation

## ◆ ERR_IMAGE_NOT_USABLE

constant int radm::KvmManager::ERR_IMAGE_NOT_USABLE = 3

Definition at line 21 of file KvmManager.idl.

## ◆ ERR_INVALID_ARGUMENT

constant int radm::KvmManager::ERR_INVALID_ARGUMENT = 1

Definition at line 19 of file KvmManager.idl.

## ◆ ERR_VM_SHARE_INACCESSIBLE

constant int radm::KvmManager::ERR_VM_SHARE_INACCESSIBLE = 2

Definition at line 20 of file KvmManager.idl.

The documentation for this interface was generated from the following file:

- KvmManager.idl